TabMix.addMethod = function () {
  // For Locked Tab
  //   code from extension Tab Utilities
  //

  TabMixLib.codeHook(
    "gBrowser.loadURI", 
    "{", 
    ( 'if (!aURI.match(/^javascript:/) && this.selectedTab.hasAttribute("locked")) {' +
      '  return this.loadOneTab(aURI, aReferrerURI, aCharset, null, null, false); }' )
  );

  TabMixLib.codeHook(
    "gBrowser.loadURIWithFlags",
    "{", 
    ( 'if (!aURI.match(/^javascript:/) && this.selectedTab.hasAttribute("locked")) {' +
      ' return this.loadOneTab(aURI, aReferrerURI, aCharset, aPostData, null, aFlags &'+
      '                        Ci.nsIWebNavigation.LOAD_FLAGS_ALLOW_THIRD_PARTY_FIXUP); }' )
  );

  TabMixLib.codeHook(
    "contentAreaClick", 
    /(\}\s*handleLinkClick)/, 
    ( 'if ( gBrowser.selectedTab.hasAttribute("locked") && gBrowser.selectedTab.getAttribute("locked") == "true" ) {' +
      '  openNewTabWith(href, event.target.ownerDocument, null, event, false);' +
      '  event.preventDefault();' +
      '  return true;' +
      '}' +
      '$&' )
  );

/*  backup for future use
  TabMixLib.codeHook(
    "XULBrowserWindow.onBeforeLinkTraversal",
    "{",
    'if ( gBrowser.selectedTab.hasAttribute("locked") ) return "_blank";'
  );
  
  TabMixLib.codeHook(
    "openLinkIn",
    "switch",
    ( 'if ( w.gBrowser.selectedTab.hasAttribute("locked") ) {' +
      '  where = "tab";' +
      '  loadInBackground = false; }' +
      '$&' )
  );
*/    

  // gBrowser.addTab
  //   check if the new tab is a related one
  //   we must do this before dispatching the "TabOpen" event
  //
  TabMixLib.codeHook(
    "gBrowser.addTab",
    't.className = "tabbrowser-tab";',
    ( '$&'+
      't.related = (aRelatedToCurrent == null ? aReferrerURI : aRelatedToCurrent);' )
  );
  
  // gBrowser.removedTab
  //   don't close protected or hidden tab
  //
  TabMixLib.codeHook(
    "gBrowser.removeTab",
    '{',
    'if ( aTab.getAttribute("protected") == "true" || aTab.hasAttribute("hidden") )'+
    '  return;'
  );
  
  // gBrowser.loadTabs
  //   override the original code
  //
  TabMixLib.codeHook(
    "gBrowser.loadTabs",
    '{',
    ( 'if (TabMixGroup.enabled) {'+
      '  TabMix.loadTabs(aURIs, aLoadInBackground, aReplace);'+
      '  return; }' )
  );
  
  // gBrowser.pinTab
  //   a pinned tab should be removed from its group (if it has)
  //
  TabMixLib.codeHook(
    "gBrowser.pinTab",
    '{',
    'if ( aTab.hasAttribute("hidden") ) {' +
    '  return; }' +
    'if ( aTab.hasAttribute("groupID") ) {' +
    '  TabMixGroup.removeOneTab(aTab); }'
  );

  // gBrowser.TMwarnAboutClosingTabs
  //   send the number of tabs to be closed when closing left or right tabs or tabs in a group
  //   

  gBrowser.TMwarnAboutClosingTabs = gBrowser.warnAboutClosingTabs;
  
  TabMixLib.codeHook(
    "gBrowser.TMwarnAboutClosingTabs",
    '(aAll)',
    '( aAll, aTabsToClose )'
  );
  
  TabMixLib.codeHook(
    "gBrowser.TMwarnAboutClosingTabs",
    'tabsToClose <= 1',
    'aTabsToClose <= 1'
  );
  
  TabMixLib.codeHook(
    "gBrowser.TMwarnAboutClosingTabs",
    '[tabsToClose]',
    '[aTabsToClose]'
  );

  // Search bar
  //   Override the click behaviour
  //
  TabMixLib.codeHook(
    "document.getElementById('searchbar').handleSearchCommand",
    'where = whereToOpenLink(aEvent, false, true);',
    ( '$&'+
      'var newTabPref = textBox._prefBranch.getBoolPref("browser.search.openintab");'+
      'if ( newTabPref ) {'+
      '  if ( where == "tab" )'+
      '    where = "current";'+
      '  else if ( where == "current" )'+
      '    where = "tab";'+
      '}' )
  );
  
  // URL bar
  //   open URL in new tab
  //
  TabMixLib.codeHook(
    "gURLBar.handleCommand",
    "{",
    'var newTabPref = __TM_Prefs.getBoolPref("opentabfor.url");'
  );
  
  TabMixLib.codeHook(
    "gURLBar.handleCommand",
    "whereToOpenLink(aTriggeringEvent, false, false);",
    ( '$&'+
      'if ( newTabPref ) {'+
      '  if ( where == "tab" ) where = "current";'+
      '  else if ( where == "current" ) where = "tab";'+
      '}'
    )
  );
  
  TabMixLib.codeHook(
    "gURLBar.handleCommand",
    /aTriggeringEvent\s*&&\s*aTriggeringEvent.altKey/,
    "( aTriggeringEvent || newTabPref ) && ( ( aTriggeringEvent ? aTriggeringEvent.altKey : false ) != newTabPref )"
  );

  // When an external application intents to open a link in new tab,
  // keep the Firefox window in background.
  // If the current tab is blank, reuse this tab instead of opening a new one.
  //
  TabMixLib.codeHook(
    "nsBrowserAccess.prototype.openURI",
    'let tab',
    ( 'let tab;' +
      'var tmLoadInBackgroundWin = __TM_Prefs.getBoolPref("openExternalBackground");'+
      'if ( tmLoadInBackgroundWin && isExternal && !loadInBackground ) {'+
      '  needToFocusWin = false;'+
      '  TabMixLib.notification();'+
      '  if ( (++TabMix.numExtTab) > 1 )'+
      '    loadInBackground = true;'+
      '}'+
      'if ( isTabEmpty(win.gBrowser.mCurrentTab) ) {'+
      '  tab = win.gBrowser.mCurrentTab;'+
      '  win.gBrowser.selectedBrowser.focus();'+
      '  if (aURI) {'+
      '    let referrer = aOpener ? makeURI(aOpener.location.href) : null;'+
      '    let loadflags = isExternal ?'+
      '                      Ci.nsIWebNavigation.LOAD_FLAGS_FROM_EXTERNAL :'+
      '                      Ci.nsIWebNavigation.LOAD_FLAGS_NONE;'+
      '    win.gBrowser.loadURIWithFlags(aURI.spec, loadflags, referrer, null, null);'+
      '  }'+
      '}'+
      'else'+
      '  tab' )
  );
  
  TabMixLib.codeHook(
    "nsBrowserAccess.prototype.openURI",
    'if (needToFocusWin || !loadInBackground && isExternal)',
    'if ( needToFocusWin || ( !loadInBackground && isExternal && !tmLoadInBackgroundWin ) )'
  );
};

// override gBrowser.loadTabs
//   set |owner| of new tabs
//   reuse the current blank tab
//   set tabs' group
//
TabMix.loadTabs = function ( aURIs, aLoadInBackground, aReplace ) {
  if (!aURIs.length)
    return;

  var owner = aLoadInBackground ? null : gBrowser.selectedTab;
  aReplace = aReplace || ( gBrowser.mCurrentBrowser.webNavigation.currentURI.spec == "about:blank" &&
                           !gBrowser.mCurrentTab.hasAttribute("busy") );
  var firstTabAdded = null;

  if (aReplace) {
    try {
      gBrowser.loadURI(aURIs[0], null, null);
    } catch (e) {
    }
  }
  else
    firstTabAdded = gBrowser.addTab(aURIs[0], {ownerTab: owner});

  if (!aLoadInBackground) {
    if (firstTabAdded) {
      gBrowser.selectedTab = firstTabAdded;
    }
    else
      window.content.focus();
  }

  for (let i = 1; i < aURIs.length; ++i) {
    let tab = gBrowser.addTab(aURIs[i], {relatedToCurrent: true});
  }
};

