const __TM_Prefs  = Services.prefs.getBranch("extensions.tabmix.");

this.TabMix = this.TabMix || {};

TabMix._Ss = Cc["@mozilla.org/browser/sessionstore;1"].getService(Ci.nsISessionStore);
    
TabMix._ClickTab_Null         = 0;
TabMix._ClickTab_OpenNewTab   = 1;
TabMix._ClickTab_RemoveTab    = 2;
TabMix._ClickTab_DuplicateTab = 3;
TabMix._ClickTab_ReloadTab    = 4;
TabMix._ClickTab_TabGroup     = 5;
TabMix._ClickTab_ProtectTab   = 6;
TabMix._ClickTab_PinTab       = 7;

TabMix._TargetLink_NewTab  = 0;
TabMix._TargetLink_Native  = 1;
TabMix._TargetLink_Current = 2;

TabMix._CloseButtonTMLite    = 4;
TabMix._CloseButtonDefault   = 1;
TabMix._CloseButtonOld       = 3;

TabMix.numExtTab      = 0;
TabMix.numClosedTab   = -1;  
TabMix.prefs          = null;
TabMix.dragOverDelay  = 600;
TabMix.unprotectDelay = 300;

TabMix.init = function () { 
  window.removeEventListener("load", TabMix.init, false);
  
  TabMix.addMethod();
  TabMix.prefObserver.register();
  
  if ( !gBrowser )
    gBrowser = document.getElementById("content");
    
  let tabContextMenu = document.getElementById("tabContextMenu");
  let contentMenu    = document.getElementById("contentAreaContextMenu");
  let toolMenu       = document.getElementById("menu_ToolsPopup");
  let appMenu        = document.getElementById("appmenu-popup");
  //let allTabsPopup   = document.getElementById("alltabs-popup");
  let tabContainer   = gBrowser.tabContainer;

  gBrowser.addEventListener("click", TabMix.onContentAreaClick, true);
  gBrowser.addTabsProgressListener(TabMix.progressListener);

  tabContainer.addEventListener("mousedown", TabMix.onMouseDown, true);
  tabContainer.addEventListener("click", TabMix.onClick, false);
  tabContainer.addEventListener("dblclick", TabMix.onTabBarDblClick, false);
  
  tabContainer.addEventListener("TabOpen", TabMix.onTabOpen, false);
  tabContainer.addEventListener("TabClose", TabMix.onTabClose, false);
  tabContainer.addEventListener("TabSelect", TabMix.onTabSelect, false);
  tabContainer.addEventListener("TabMove", TabMix.onTabMove, false);
  tabContainer.addEventListener("SSTabRestoring", TabMix.onSSTabRestoring, false);
  tabContainer.addEventListener("SSTabRestored", TabMix.onSSTabRestored, false);
  
  tabContainer.addEventListener("dragover", TabMix.onDragOver, false);
  tabContainer.addEventListener("dragend", TabMix.onDragEnd, false);
  tabContainer.addEventListener("drop", TabMix.onDrop, false);

  tabContainer.addEventListener("mousemove", TabMix.onTabDrag, false);
  tabContainer.addEventListener("scroll", TabMix.onTabDragScroll, false);
  tabContainer.addEventListener("TabSelect", TabMix.onEndTabDrag, false);
  tabContainer.addEventListener("mouseup", TabMix.onTabDrop, false);
  
  //allTabsPopup.addEventListener("popupshown", TabMix.onAllTabsPopupShown, false);    
  tabContextMenu.addEventListener("popupshowing", TabMix.onTabbarContext, false);
  contentMenu.addEventListener("popupshowing", TabMix.onContentMenu, false);
  toolMenu.addEventListener("popupshowing", TabMix.checkResumeSessionOnceMenu, false);

  if (appMenu)
    appMenu.addEventListener("popupshowing", TabMix.checkResumeSessionOnceMenu, false);
 
  TabMix.prefs = Services.prefs;
  TabMix._persistAttribute();
  TabMix.onUpdate();
  
  if (gBrowser.mCurrentTab) {
    let current = gBrowser.mCurrentTab;
    TabMix._initTab(current);
    if ( current._tPos == 0 )
      current.setAttribute("visited", "true");
  }
  
  // set lock icon for gtk theme
  if ( TabMixLib.setCSS("chrome://browser/skin/browser.css",
                        "#home-button",
                        "list-style-image",
                        null).indexOf("gtk-home") > -1 )                          
    TabMixLib.setCSS("chrome://tabmix/content/tab.css",
                     '.tabbrowser-tab[protected="true"]:not([pinned="true"]) .tab-close-button',
                     "list-style-image",
                     'url("chrome://browser/skin/Secure.png")');
};

TabMix.uninit = function () {
  TabMix.prefObserver.unregister();

  let tabContextMenu = document.getElementById("tabContextMenu");
  let contentMenu    = document.getElementById("contentAreaContextMenu");
  let toolMenu       = document.getElementById("menu_ToolsPopup");
  let appMenu        = document.getElementById("appmenu-popup");
  //let allTabsPopup   = document.getElementById("alltabs-popup");
  let tabContainer   = gBrowser.tabContainer;

  gBrowser.removeEventListener("click", TabMix.onContentAreaClick, true);
  gBrowser.removeTabsProgressListener(TabMix.progressListener);

  tabContainer.removeEventListener("mousedown", TabMix.onMouseDown, true);
  tabContainer.removeEventListener("click", TabMix.onClick, false);
  tabContainer.removeEventListener("dblclick", TabMix.onTabBarDblClick, false);
  
  tabContainer.removeEventListener("TabOpen", TabMix.onTabOpen, false);
  tabContainer.removeEventListener("TabClose", TabMix.onTabClose, false);
  tabContainer.removeEventListener("TabSelect", TabMix.onTabSelect, false);
  tabContainer.removeEventListener("TabMove", TabMix.onTabMove, false);
  tabContainer.removeEventListener("SSTabRestoring", TabMix.onSSTabRestoring, false);
  tabContainer.removeEventListener("SSTabRestored", TabMix.onSSTabRestored, false);
  
  tabContainer.removeEventListener("dragover", TabMix.onDragOver, false);
  tabContainer.removeEventListener("dragend", TabMix.onDragEnd, false);
  tabContainer.removeEventListener("drop", TabMix.onDrop, false);
  
  tabContainer.removeEventListener("mousemove", TabMix.onTabDrag, false);
  tabContainer.removeEventListener("scroll", TabMix.onTabDragScroll, false);
  tabContainer.removeEventListener("TabSelect", TabMix.onEndTabDrag, false);
  tabContainer.removeEventListener("mouseup", TabMix.onTabDrop, false);
  
  //allTabsPopup.addEventListener("popupshown", TabMix.onAllTabsPopupShown, false);
  tabContextMenu.removeEventListener("popupshowing", TabMix.onTabbarContext, false);
  contentMenu.removeEventListener("popupshowing", TabMix.onContentMenu, false);
  toolMenu.removeEventListener("popupshowing", TabMix.checkResumeSessionOnceMenu, false);

  if (appMenu)
    appMenu.removeEventListener("popupshowing", TabMix.checkResumeSessionOnceMenu, false);
};

/*
 * Persist tab attributes
 */
TabMix._persistAttribute = function() {
  this._Ss.persistTabAttribute("hidden");
  this._Ss.persistTabAttribute("visited"); 
  this._Ss.persistTabAttribute("protected");
  this._Ss.persistTabAttribute("locked");
  this._Ss.persistTabAttribute("groupID"); 
  this._Ss.persistTabAttribute("oldGroup");
};

/*
 * update the attributes in all Tabs
 */
TabMix.onUpdate = function () {
  try {
    var maxWidth       = this.prefs.getIntPref("browser.tabs.tabMaxWidth");
    var minWidth       = this.prefs.getIntPref("browser.tabs.tabMinWidth");
    var related        = this.prefs.getBoolPref("browser.tabs.insertRelatedAfterCurrent");
    var closeButton    = __TM_Prefs.getIntPref("closeButtons");
    var unreadTab      = __TM_Prefs.getBoolPref("unreadTab");
    var group          = __TM_Prefs.getBoolPref("tabGroup");
    var autoLock       = __TM_Prefs.getBoolPref("lockProtectedTab");
  }
  catch(e) {
    var maxWidth       = 250;
    var minWidth       = 100;
    var related        = true;
    var closeButton    = this._CloseButtonDefault;
    var unreadTab      = false;
    var group          = true;
    var autoLock       = false;
  }
  
  var tabs    = gBrowser.tabs;
  var tabBar  = gBrowser.tabContainer;
  //var allTabs = document.getElementById("alltabs-popup");
  var TMCloseButton = (closeButton == this._CloseButtonTMLite);
  let nativeButton = TMCloseButton ? this._CloseButtonOld : closeButton;
  if ( this.prefs.getIntPref("browser.tabs.closeButtons") != nativeButton )
    this.prefs.setIntPref("browser.tabs.closeButtons", nativeButton);    
  
  tabBar.setAttribute("unread", unreadTab);
  tabBar.setAttribute("tmCloseButton", TMCloseButton);

  // Colorful Tabs Group
  group = group && related;
  TabMixGroup.enabled = group;
  if (group)
    __TM_Prefs.setBoolPref("showMoveToGroup", false);
  let TabViewCommand = document.getElementById("Browser:ToggleTabView");
  let TabViewDeck = document.getElementById("tab-view-deck");
  TabViewCommand.setAttribute("oncommand", group ? "return;" : "TabView.toggle();");
  TabViewDeck.setAttribute("grouping", group);
  tabBar.setAttribute("grouping", group);
  //allTabs.setAttribute("grouping", group);
    
  /* set tab width */
  TabMixLib.setCSS( "chrome://browser/content/browser.css",
                    ".tabbrowser-tab:not([pinned])",
                    "max-width",
                    maxWidth + "px" );
  TabMixLib.setCSS( "chrome://browser/content/browser.css",
                    ".tabbrowser-tab:not([pinned])",
                    "min-width",
                    minWidth + "px" );
  
  /* automatically lock protected tabs */
  let tabs = Array.filter(gBrowser.tabs, function(tab) {
              return tab.hasAttribute("protected");
             });
  Array.forEach( tabs, function(tab) {
    if (autoLock)
      tab.setAttribute("locked", true);
    else
      tab.removeAttribute("locked");
  });
};

/*
 * Tab events
 */

// Regroup tabs
//
//  In any of the cases below, we don't do anything
//   1. when Firefox move a related tab next to the opener
//   2. when restoring a closed tab, see below
//   3. when Tab Mix Lite tries to move a tab to its correct position
//
TabMix.onTabMove = function (event) {
  if ( !TabMixGroup.enabled )
    return;
    
  let tab = event.target;
  
  // when restoring a closed tab, onTabMove() will be called firstly by Firefox restore function,
  // and we have to call TabMixGroup.moveRestoredTab() here, because onSSTabRestored() will only
  // be called after the restored page is finished loading.
  if ( tab._restoring ) {
    TabMixGroup.moveRestoredTab(tab);
    return;
  }

  // what function have called gBrowser.moveTabTo() ?
  // |caller| is no-standard but useful
  try {
    let callerName = arguments.callee.caller.caller.name;
    if ( callerName == "addTab" || 
         callerName == "TM_moveTabTo" )
      return;
  }
  catch (e) { 
    TabMixLib.msg("onTabMove can't get caller"); // would be the case of tabviewhide
    //return;
  }

  let nextTab = TabMix.nextTab(tab);
  let prevTab = TabMix.prevTab(tab);

  let oID    = tab.groupID;
  let nextID = nextTab == null ? null : nextTab.groupID;
  let prevID = prevTab == null ? null : prevTab.groupID;

  // the moved tab is dropped beside a tab stack
  // see TabMixGroup.tabBeforeStack() && tabAfterStack()
  let beside = false;
  if ( prevID && prevTab.hasAttribute("hidden") && prevTab.getAttribute("hidden") != "true" &&
       tab.nextSibling && tab.nextSibling.groupID == prevID ) {
    TabMixGroup.tabAfterStack(tab, prevTab, event.detail);
    beside = true;
  }
  if ( nextID && nextTab.hasAttribute("hidden") && nextTab.getAttribute("hidden") != "true" &&
       tab.previousSibling && tab.previousSibling.groupID == nextID ) {
    TabMixGroup.tabBeforeStack(tab, nextTab, event.detail);
    beside = true;
  }
  if (beside)
    return;

  // when a tab stack is moved, all the tabs should be moved together
  //
  // when moving the other tabs of the stack, onTabMove() will be called again
  // so we need to set TabMixGroup.moving to true, to prevent an infinited loop
  // see TabMixGroup.moveStack()
  //
  // event.detail is the tab's original position
  //
  if ( tab.hasAttribute("hidden") && !TabMixGroup.moving ) {
    TabMixGroup.moveStack(tab, event.detail, true);
    return;
  }
      
  // still in its own group, or the moved tab and its neighbors are all orphan tabs
  if ( oID == nextID || oID == prevID ) {
    let prevParent = prevTab ? ( null || prevTab._opener ) : null;
    let nextParent = nextTab ? ( null || nextTab._opener ) : null;
    if ( oID && prevTab && nextTab && prevParent == nextParent )
      tab._opener = nextTab._opener;
    return;
  }

  // outside its original group
  if ( oID && !TabMixGroup.moving )
    TabMixGroup.removeOneTab(tab);
  
  // into another group 
  if ( nextID && nextID == prevID ) {
    TabMixGroup.setID(tab, nextID);
    tab.removeAttribute("hidden");
    tab._opener = nextTab._opener;
  }
  // new position has no group
  else {
    if ( oID )
      tab._opener = null;
  }
};

// When Tab is selected, set |visited|
//
TabMix.onTabSelect = function (event) {
  TabMix.numPinTab = 0;
  var tab = event.target;
  tab.setAttribute("visited", true);
};

// "Smart focus" after closing a tab
//
TabMix.onTabClose = function (event) {
  TabMix.numClosedTab++;

  if ( !TabMixGroup.enabled || !TabMix.prefs.getBoolPref("browser.tabs.selectOwnerOnClose") )
    return;
    
  let tab = event.target;
  let group = tab.groupID;
  let isCurrent = tab.hasAttribute("selected");
  
  let target = null || tab._opener;
  let newTab = null;
  let nextTab = TabMix.nextTab(tab);
  let prevTab = TabMix.prevTab(tab);

  if (group) {
    if ( target && isCurrent ) {
      let tabs = TabMixGroup.getTabsInGroup(group);
      let inside = ( tabs.indexOf(target) >= 0 ); // whether the opener is in the same group

      Array.forEach( tabs, function (tempTab) {
        // pass the opener to its children
        // and also to its orphan siblings if the opener is outside the group
        if ( tempTab._opener == tab || ( tempTab._opener == null && !inside ) )
          tempTab._opener = target;
      });

      if ( nextTab && nextTab.groupID == group && nextTab._opener == target ) {
        newTab = nextTab;
//TabMixLib.msg("next:: target:"+tab._tPos+","+target._tPos+" nextTab:"+nextTab._tPos+","+ ( nextTab._opener == null ? "null" : nextTab._opener._tPos ) );
        }
      else if ( prevTab && prevTab.groupID == group && prevTab._opener == target )
        newTab = prevTab;
      else if (inside) // opener inside the group, no siblings, go back to its opener
        newTab = target;
      // opener outside the group, no siblings, newTab = null
    }
    if ( !newTab && isCurrent ) {
      if ( nextTab && nextTab.groupID == group )
        newTab = nextTab;
      else if ( prevTab && prevTab.groupID == group )
        newTab = prevTab;
      // error (siblings not found), newTab = null
    }
    TabMixGroup.removeOneTab(tab);
  }
  else {
    let orphan = false;
    Array.forEach( gBrowser.visibleTabs, function (tempTab) {
      if ( tempTab._opener == tab )
        orphan = true;
    });
    if (orphan) {
      TabMix._clearOpener();
      return;
    }
    if (target)
      newTab = target;
  }

  // it's a background tab we don't need to select other tab
  if ( !isCurrent )
    return;

  if ( newTab && gBrowser.visibleTabs.indexOf(newTab) >= 0 ) {
    gBrowser.selectedTab = newTab;      
    newTab.setAttribute("visited", true);
  }
};

// When opening a tab, check if it's in a tab group or a popup
//
TabMix.onTabOpen = function (event) {
  var tab = event.target;
  TabMix._initTab(tab);
  
  if ( !TabMixGroup.enabled )
    return;
      
  let current = gBrowser.mCurrentTab;
  
  if ( current.pinned ) {
    if ( tab.related && gBrowser._lastRelatedTab )
      TabMixGroup.addFromTab(tab, gBrowser.tabs[gBrowser._numPinnedTabs]);
    tab._opener = current;
  }
  else {
    if ( gBrowser._lastRelatedTab == null ) {
      current._allowOpener = true;
      let tabs = TabMixGroup.getTabsInGroup(current);
      Array.forEach( tabs, function (tempTab) {
        if ( tempTab._opener == current )
          tempTab._opener = null;
      });        
    }
      
     // new group to be created
    if ( tab.related && current.groupID == null ) {
      current._allowOpener = false;
      // we have already some related tabs opened, but these tabs are not grouped
      if ( gBrowser._lastRelatedTab )
        gBrowser._lastRelatedTab = null;
    }

    // numExtTab: tabs opened from external app
    if ( tab.related || TabMix.numExtTab > 1 )
      TabMixGroup.addFromTab(tab, current);
    
    if ( tab.owner || ( tab.related && current._allowOpener ) )
      tab._opener = current;
  }
};

// Don't do anything when restoring a session
TabMix.onSSTabRestoring = function (event) {
  // hack to know whether we are reopening a browser or calling undoclosetab
  let realCount = TabMix._Ss.getClosedTabCount(window);
  let tempCount = TabMix.numClosedTab;
  
  let tab = event.target;
  if ( tab.hasAttribute("visited") )
    tab.visited = true;
  if ( tab.hasAttribute("groupID") )
    tab.groupID = tab.getAttribute("groupID");
/*
  if ( tempCount == realCount ) // session restoring
    return;
  else { // undoclosetab when tempCount != -1
    TabMix.numClosedTab = realCount;
    if ( tempCount == -1 ) // browser is just opened
      return;
  }
*/  
  TabMixGroup.restore(tab);
};

TabMix.onSSTabRestored = function (event) { 
  if ( event.target._restoring )
    TabMixGroup.moveRestoredTab(event.target);
};

TabMix.onWindowActive = function () {
  TabMix.numExtTab = 0;
  
  let allTabsPopup   = document.getElementById("alltabs-popup");
  if (allTabsPopup) {
    document.getElementById("menu_tabview").hidden = TabMixGroup.enabled ;
    document.getElementById("alltabs-popup-separator").hidden = TabMixGroup.enabled;
  }
};

/*
 * For catching changes of preferences and update existing tabs
 */
TabMix.prefObserver = {
  _branch : "extensions.tabmix.",
  
  register: function () {
    Services.prefs.addObserver(this._branch, this, false);
    Services.prefs.addObserver("browser.tabs.tabMaxWidth", this, false);
    Services.prefs.addObserver("browser.tabs.tabMinWidth", this, false);
  },

  unregister: function () {
    Services.prefs.removeObserver(this._branch, this, false);
    Services.prefs.removeObserver("browser.tabs.tabMaxWidth", this, false);
    Services.prefs.removeObserver("browser.tabs.tabMinWidth", this, false);
  },

  observe: function (aSubject, aTopic, aData) {
    if (aTopic == "nsPref:changed")
      TabMix.onUpdate();
  }
};

/*
 * For unread tab
 */
TabMix.progressListener = {
  onStateChange : function ( aBrowser, aWebProgress, aRequest, aStateFlags, aStatus ) {  
    if (!aRequest)
      return;
    const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;

    if ( aStateFlags & nsIWebProgressListener.STATE_STOP &&
         aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK) {
      for ( let i = 0; i < gBrowser.tabs.length; i++ ) {
        let tab = gBrowser.tabs[i];
        if ( tab.linkedBrowser == aBrowser ) {
          if ( tab.hasAttribute("visited") && !tab.hasAttribute("selected") ) {
            if ( !tab.visited )
              tab.removeAttribute("visited");
            tab.visited = null;
          }
          break;
        }
      }
    }
  }
};

window.addEventListener("load", TabMix.init, false);
window.addEventListener("unload", TabMix.uninit, false);
window.addEventListener("activate", TabMix.onWindowActive, false);
